#!/usr/bin/python

import os.path
import time
import sys
import optparse

("Check the status of lock file to be sure it is not stale, "
 "warn at 7200 seconds crit at 14400 seconds")

parser = optparse.OptionParser()
parser.add_option('-w', action="store", default="7200", help="seconds to warn",
                  type="int")
parser.add_option('-c', action="store", default="14400", help="seconds to crit",
                  type="int")
parser.add_option('-f', action="store", default="/tmp/glance_sync_slave.lock",
                  help="file to check",
                  type="string")

options, args = parser.parse_args()

nagOk = 0
nagWarn = 1
nagCrit = 2

try:
    statInfo = os.stat(options.f)
except OSError:
    print("OK: lockfile {} not present".format(options.f))
    sys.exit(nagOk)

now = int(time.time())
statInfoSlice = statInfo[8]
timeDiff = now - statInfoSlice

if timeDiff > options.c:
    print("CRIT: lock file is older than {} seconds".format(options.c))
    sys.exit(nagCrit)
elif timeDiff > options.w:
    print("WARN: lock file is older than {} seconds".format(options.w))
    sys.exit(nagWarn)
else:
    print("OK: lock file is under 3 hours")
    sys.exit(nagOk)
